% The MIT License (MIT)
% Copyright (c) 2016 Elmar Rueckert, Daniel Tanneberg, David Kappel
% 
% Permission is hereby granted, free of charge, to any person obtaining a 
% copy of this software and associated documentation files (the "Software"), 
% to deal in the Software without restriction, including without limitation 
% the rights to use, copy, modify, merge, publish, distribute, sublicense, 
% and/or sell copies of the Software, and to permit persons to whom the 
% Software is furnished to do so, subject to the following conditions:
% 
% The above copyright notice and this permission notice shall be included
% in all copies or substantial portions of the Software.
% 
% THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS 
% OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
% FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
% THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
% LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
% FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
% DEALINGS IN THE SOFTWARE. 

% **********************************************************
% *
% * Supplementary Code to 
% *                       Recurrent Spiking Networks Solve Planning Tasks, 
% *                       Scientific Reports, 6, 21142, Nature Publishing Group.
% * 
% *                       Rueckert, Elmar and Kappel, David and Tanneberg, Daniel
% *                       and Pecevski, Dejan and Peters, Jan (2016).
% * 
% * If you use this code, please cite the paper!
% * 
% * contact: rueckert.elmar@gmail.com, tanneberg@ias.tu-darmstadt.de, david.kappel@igi.tugraz.at
% *
% **********************************************************
function [reward flgHitObstacle flgHitTarget flgHitNothing] = fnRewardMazeSingleState(state, initState, targetState, obstacleStates, rewardTarget, rewardObstacle)
%maze reward function
%       rewardObstacle (e.g., -20) if obstacle is hit
%       rewardTarget (e.g., +100) if target reached
%       0 else

flgHitObstacle = 0;
flgHitTarget = 0;
flgHitNothing = 0;

if 1==1 %with obstalces

    hitXIds = find(state(1) - obstacleStates(1,:) == 0);
    hitYIds = find(state(2) - obstacleStates(2,:) == 0);
    hitIds = intersect(hitXIds, hitYIds);

    if ~isempty(hitIds)
        reward = rewardObstacle;
        flgHitObstacle = 1;
    elseif ( targetState(1) - state(1) )^2 + ( targetState(2) - state(2) )^2 < 1
        reward = rewardTarget;
        flgHitTarget = 1;
    else
        reward = 0;
        flgHitNothing = 1;
    end

else
    if ( targetState(1) - state(1) )^2 + ( targetState(2) - state(2) )^2 < 1
        reward = rewardTarget;
    else
        reward = 0;
    end
end
