% The MIT License (MIT)
% Copyright (c) 2016 Elmar Rueckert, Daniel Tanneberg, David Kappel
% 
% Permission is hereby granted, free of charge, to any person obtaining a 
% copy of this software and associated documentation files (the "Software"), 
% to deal in the Software without restriction, including without limitation 
% the rights to use, copy, modify, merge, publish, distribute, sublicense, 
% and/or sell copies of the Software, and to permit persons to whom the 
% Software is furnished to do so, subject to the following conditions:
% 
% The above copyright notice and this permission notice shall be included
% in all copies or substantial portions of the Software.
% 
% THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS 
% OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
% FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
% THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
% LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
% FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
% DEALINGS IN THE SOFTWARE. 

% **********************************************************
% *
% * Supplementary Code to 
% *                       Recurrent Spiking Networks Solve Planning Tasks, 
% *                       Scientific Reports, 6, 21142, Nature Publishing Group.
% * 
% *                       Rueckert, Elmar and Kappel, David and Tanneberg, Daniel
% *                       and Pecevski, Dejan and Peters, Jan (2016).
% * 
% * If you use this code, please cite the paper!
% * 
% * contact: rueckert.elmar@gmail.com, tanneberg@ias.tu-darmstadt.de, david.kappel@igi.tugraz.at
% *
% **********************************************************
function plotMaze(Kx, Ky, wh)

grayColor = 0.7*[1 1 1];

xRec = -wh/2 + linspace(1,Kx,Kx);
yRec = -wh/2 + linspace(1,Ky,Ky);

%top and bottom walls
w = wh;
h = wh;
for xId=1:Kx
    x = xRec(xId); 
    y = yRec(1); 
    rectangle('Position',[x,y,w,h], 'FaceColor',grayColor, 'EdgeColor','w');
    y = yRec(end); 
    rectangle('Position',[x,y,w,h], 'FaceColor',grayColor, 'EdgeColor','w');
end
% keyboard

%left and right walls
w = wh;
h = wh;
for yId=2:Ky-1
    y = yRec(yId); 
    x = xRec(1); 
    rectangle('Position',[x,y,w,h], 'FaceColor',grayColor, 'EdgeColor','w');
    x = xRec(end); 
    rectangle('Position',[x,y,w,h], 'FaceColor',grayColor, 'EdgeColor','w');
end
% keyboard

%obstacle 1 
x = xRec(ceil(Kx/2));
for yId=9:14
    y = yRec(yId); 
    rectangle('Position',[x,y,w,h], 'FaceColor',grayColor, 'EdgeColor','w');
end
% keyboard
%obstacle 2 
for yId=4:7
    y = yRec(yId); 
    rectangle('Position',[x,y,w,h], 'FaceColor',grayColor, 'EdgeColor','w');
end
% keyboard
%obstacle 3 
y = yRec(3);
for xId=6:10
    x = xRec(xId); 
    rectangle('Position',[x,y,w,h], 'FaceColor',grayColor, 'EdgeColor','w');
end
% keyboard
end