% The MIT License (MIT)
% Copyright (c) 2016 Elmar Rueckert, Daniel Tanneberg, David Kappel
% 
% Permission is hereby granted, free of charge, to any person obtaining a 
% copy of this software and associated documentation files (the "Software"), 
% to deal in the Software without restriction, including without limitation 
% the rights to use, copy, modify, merge, publish, distribute, sublicense, 
% and/or sell copies of the Software, and to permit persons to whom the 
% Software is furnished to do so, subject to the following conditions:
% 
% The above copyright notice and this permission notice shall be included
% in all copies or substantial portions of the Software.
% 
% THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS 
% OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
% FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
% THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
% LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
% FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
% DEALINGS IN THE SOFTWARE.

% **********************************************************
% *
% * Supplementary Code to 
% *                       Recurrent Spiking Networks Solve Planning Tasks, 
% *                       Scientific Reports, 6, 21142, Nature Publishing Group.
% * 
% *                       Rueckert, Elmar and Kappel, David and Tanneberg, Daniel
% *                       and Pecevski, Dejan and Peters, Jan (2016).
% * 
% * If you use this code, please cite the paper!
% * 
% * contact: rueckert.elmar@gmail.com, tanneberg@ias.tu-darmstadt.de, david.kappel@igi.tugraz.at
% *
% **********************************************************

close all;
clear all;
clc;

q0 = pi/180*[180, -140]';                              %initial joint angles
qT = pi/180*[150, -30]';                              %terminal joint angles

numTimeSteps = 100;                                 %number of discrete time steps of the trajectory
qTraj = [linspace(q0(1),qT(1), numTimeSteps); ...
         linspace(q0(2),qT(2), numTimeSteps)];      %demo trajectory
     
     
%Various Plot Function Calls
%INIT
hndArmVisualizer = plotTwoLinkRobotArm(q0);
%SINGLE STATE
% hndArmVisualizer = plotTwoLinkRobotArm(qT, hndArmVisualizer);
%TRAJECTORY
hndArmVisualizer = plotTwoLinkRobotArm(qTraj, hndArmVisualizer);
figure; plot(hndArmVisualizer.efTrace');
legend('x', 'y');

%TASK SPACE TRAJECTORY
hndArmVisualizer2 = plotTwoLinkRobotArm();
hndArmVisualizer2 = plotTwoLinkRobotArm(hndArmVisualizer.efTrace, hndArmVisualizer2, 1); % , qTraj
figure; plot(hndArmVisualizer2.efTrace');
legend('x', 'y');
