% The MIT License (MIT)
% Copyright (c) 2016  Daniel Tanneberg, David Kappel, Elmar Rueckert
% 
% Permission is hereby granted, free of charge, to any person obtaining a 
% copy of this software and associated documentation files (the "Software"), 
% to deal in the Software without restriction, including without limitation 
% the rights to use, copy, modify, merge, publish, distribute, sublicense, 
% and/or sell copies of the Software, and to permit persons to whom the 
% Software is furnished to do so, subject to the following conditions:
% 
% The above copyright notice and this permission notice shall be included
% in all copies or substantial portions of the Software.
% 
% THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS 
% OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
% FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
% THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
% LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
% FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
% DEALINGS IN THE SOFTWARE. 

% **********************************************************
% *
% * Supplementary Code to 
% *                       Recurrent Spiking Networks Solve Planning Tasks, 
% *                       Scientific Reports, 6, 21142, Nature Publishing Group.
% * 
% *                       Rueckert, Elmar and Kappel, David and Tanneberg, Daniel
% *                       and Pecevski, Dejan and Peters, Jan (2016).
% * 
% * If you use this code, please cite the paper!
% * 
% * contact: tanneberg@ias.tu-darmstadt.de, david.kappel@igi.tugraz.at, rueckert.elmar@gmail.com
% *
% **********************************************************
function hfig = plotSpikeTrain(spikeTrain)
%   plot given spiketrain with line objects
    hfig = figure; 
    set(hfig, 'color','white');
    xlabel('time (ms)');
    ylabel('neuron id');
    axis([1 size(spikeTrain,2) 1 size(spikeTrain,1)+2]);
    set(gca,'Color',[0.85 0.85 0.85]);
    set(gca, 'FontSize' , 13);

    if size(spikeTrain,1) == 225
       set(gca,'YTick',[1 25 50 75 100 125 150 175 200 225],'YTickLabel',{'1', ' ', '50', ' ', '100', ' ', '150', ' ', '200', '225'});
    elseif size(spikeTrain,1) == 245
        set(gca,'YTick',[1 25 50 75 100 125 150 175 200 225 235 245],'YTickLabel',{'1', ' ', '50', ' ', '100', ' ', '150', ' ', '200', '225', ' ', '245'});
    end
    
    hold all;    
    [rows,cols] = find(spikeTrain >= 1);
    for k=1:numel(rows)
        line([cols(k) cols(k)],[rows(k) rows(k)+1],'Color','k','LineWidth',1.0);
    end

end

 
